// file name:  cam.c
// Date: Jul 4, 2003
// Edited by:  E.Inoue
//
// Parallel camac
// packet format of basic camac opeation
// TX
// +---------+-------+-------+-------+-------+---------------------------+
// |   cmd   |   N   |   A   |   F   |       |       24-bit DATA         |
// +---------+-------+-------+-------+-------+---------------------------+
//
// RX
// +---------+-------+-------+-------+-------+---------------------------+
// |  rply   |   N   |   A   |   F   |  ST   |       24-bit DATA         |
// +---------+-------+-------+-------+-------+---------------------------+

#include    <stdio.h>
#include    <jni.h>
#include    <sys/io.h>
#include    "cam.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <sys/poll.h>
#include "pcc.h"

JNIEXPORT jint JNICALL 
Java_cam_cmdArray(JNIEnv *env, jobject obj, jintArray r_cmd, jintArray r_dat, jintArray cmd_buf, jintArray rpl_buf, jint length1, jint examN)
{
   int	sum = 0;
   jsize	len1 = (*env)->GetArrayLength(env, r_cmd);
   jint		*c_cmd = (*env)->GetIntArrayElements(env, r_cmd, 0);

   jsize	len2 = (*env)->GetArrayLength(env, r_dat);
   jint		*c_dat = (*env)->GetIntArrayElements(env, r_dat, 0);

   jsize	len3 = (*env)->GetArrayLength(env, cmd_buf);
   jint		*ccmdbuf = (*env)->GetIntArrayElements(env, cmd_buf, 0);

   jsize	len4 = (*env)->GetArrayLength(env, rpl_buf);
   jint		*crplybuf = (*env)->GetIntArrayElements(env, rpl_buf, 0);

   int		example = examN;

   int		fd, i;
   int		QX;
   int		wdata, rdata, cmd, reply;


   printf ("\n   JNI, C side: Received CAMAC command: ");
   printf ("array length = %d\n", length1); 

   printf ("example number = %d\n", example); 

   // camac Single action from remote machine.
   ccmdbuf[1] = length1 * 2;
   for (i=0; i < length1 +1; i++) {
      printf("      c_cmd[%d] = 0x%x, c_dat[%d] = 0x%x\n", i, c_cmd[i], i, c_dat[i]);
   }

   if((fd = cam_open( )) == -1) {
      printf("cam_open error\n");
//    exit(0);
   }

   cmd = c_cmd[0];
   wdata = c_dat[0] & 0x00ffffff;

   cam_put( fd, wdata, cmd );
   cam_get( fd, &rdata, &reply );


   QX = (rdata >> 24) & 3;
   printf("Q = %d : X = %d ", QX&1, (QX>>1)&1);
   printf(": data = %x", (rdata&0xFFFFFF));

   c_cmd[0] = reply;
   c_dat[0] = rdata;

   cam_close( fd );

   (*env)->ReleaseIntArrayElements(env, r_cmd, c_cmd, 0);
   (*env)->ReleaseIntArrayElements(env, r_dat, c_dat, 0);
   (*env)->ReleaseIntArrayElements(env, cmd_buf, ccmdbuf, 0);
   (*env)->ReleaseIntArrayElements(env, rpl_buf, crplybuf, 0);
   return sum;
}
